
/* -----------------------------------------------------------------------
   A. Veneziani -  Programma che dati due punti calcola l'equazione
                   della retta passanti per essi

                   Scritto in C++ Builder 6

   ----------------------------------------------------------------------- */


#include <iostream>
#include "Math.hpp"        // contiene definizione della costante Infinity e della
                           // funzione IsInfinite

using namespace std;

// definisce la struttura che rappresenta un punto
struct punto {
    float x;
    float y;
};

// definisce la struttura che rappresenta una retta
struct retta {
    float m;
    float q;
};        

int main()
{
    retta r;
    punto p1, p2;

    // legge le coordinate di due punti
    cout << "Inserisci le coordinate del primo punto per cui passa la retta (x y):  ";
    cin >> p1.x >> p1.y;
    cout << "Inserisci le coordinate del secondo punto per cui passa la retta (x y):  ";
    cin >> p2.x >> p2.y;

    //
    // y = m x + q
    //

    // calcolo coefficiente m

    // se la retta NON e' orizzontale o verticale...
    if (((p2.x - p1.x) != 0) && ((p2.y - p1.y) != 0))
        r.m = (p2.y - p1.y) / (p2.x - p1.x);

    // se la retta e' verticale...    
    if ((p2.x - p1.x) == 0)   r.m = Infinity;    // (costante infinito predefinita)
    // se la retta e' orizzontale...
    if ((p2.y - p1.y) == 0)   r.m = 0;

    // calcolo coefficiente q
    r.q = p1.y - (r.m * p1.x);

    // output opportuni a seconda dei valori assunti da m e q...
    if (r.m == 0)
        cout << "La retta che passa per i due punti ha equazione:  y = " << r.q << endl;
    else  if (IsInfinite(r.m))  // ...controlla se m ha assunto il valore infinito...
        cout << "La retta che passa per i due punti ha equazione:  x = " << p1.x << endl;
    else
        cout << "La retta che passa per i due punti ha equazione:  y = " << r.m << " * x + " << r.q << endl;

    system("PAUSE");     // si ferma fino a che non si preme un tasto

    return(0);
}
